// The graph that is displayed by the graph viewer

class Graph {
 
 java.util.Hashtable nodes;
 java.util.Hashtable links;
 boolean shownodeid;
 java.util.Enumeration graphenum;
 
 boolean showAllConnections = false;
 
 Node source = null;
 int radial_radius = 80;
  
 //constructor
 Graph() {
   nodes = new java.util.Hashtable(200);
   links = new java.util.Hashtable(500);
   shownodeid = true;
 } 
 
 //adds a node to the hashtable
 void add(Node anode) {
   nodes.put(anode.id, anode); 
   
   //how to determine original center node?
   if(source == null && !anode.id.equals("1.2.3.4:2000")) { 
     source = anode;
   }
 }
 
  //adds a link to the hashtable
 void add(Link alink) {
   String id = alink.node1.id + "-" + alink.node2.id + "-" + alink.connectionType;
   links.put(id, alink); 
 }
 
 //returns a Node object that has the specified id, or null if not found
 Node getNode(String id) {
  return (Node)nodes.get(id);
 }
 
 //returns the number of nodes
 int numNodes() {
   return nodes.size();
 }
 
 //draws all of the nodes
 void drawNodes() {
   for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         ((Node)graphenum.nextElement()).drawMe();
     }
 }
 
 //draws all of the links
 void drawLinks() {
   for(graphenum = links.elements() ; graphenum.hasMoreElements() ;) {
         ((Link)graphenum.nextElement()).drawMe();
     }
 }

//returns the closest node to the (x,y) coordinate passed in
//or null if no node within tolerance
Node getClosestNode(int x, int y) {
 float tolerance = 200;
 Node testNode, closestNode = null;
 float cloestDistance = tolerance, squaredDist;
 
 for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         testNode = (Node)graphenum.nextElement();
         squaredDist = squaredDistance(testNode.x, testNode.y, x, y);
         
         if(squaredDist < tolerance && squaredDist < cloestDistance) {
            closestNode = testNode;
            cloestDistance = squaredDist;
            }
     }
 
 return closestNode;
}

float squaredDistance(float x1, float y1, float x2, float y2) {
  return (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2);
}



void radialLayout() {
    java.util.ArrayList q = new ArrayList();
    Node u, v;
    Link l;
  
  //initialize
  if(source != null) {
   for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
          u = (Node)graphenum.nextElement();
          u.d = INT_MAX;
          u.parent = null;
      }
   source.d = 0;

   //perform BFS
   q.add(source);
   while(q.size() > 0) {
      u = (Node)q.remove(0);
      for(graphenum = u.links.elements() ; graphenum.hasMoreElements() ;) {
          l = (Link)graphenum.nextElement();
          if(l.connectionType == 1000) {
             if(l.node1 == u) { v = l.node2; }
             else { v = l.node1; }
             if(v.d == INT_MAX) {
              v.d = u.d + 1;
              v.parent = u;
              q.add(v);
             } 
          }
      }
   }
  
   //palce bfs nodes
   source.getNumberOfLeaves();
   source.place(0, 2*PI);
   //place all nodes with no parent out of the screen
   for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
          u = (Node)graphenum.nextElement();
          if(u.parent == null && graph.source != u) { u.changePosition(FLT_MAX, FLT_MAX); }
      }
  screenDirty = true;
  //lets get outta here
  }
} //end radialLayout()


//move each node x and y one step toward newx and newy
void nodeTransition() {
   float xtotal, ytotal, frac = (1.0*transitionFrame) / totalTransitionFrames;
   Node n;
   
   for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
          
          n = (Node)graphenum.nextElement();
          xtotal = n.afterx - n.beforex;
          ytotal = n.aftery - n.beforey;
          n.x = n.beforex + frac*xtotal;
          n.y = n.beforey + frac*ytotal;
      }

}




 
} //end Graph class
