// The graph that is displayed by the graph viewer

class Graph {
 
 java.util.Hashtable nodes;
 java.util.Hashtable links;
 Node selectedNode;
 boolean shownodeid;
 java.util.Enumeration graphenum;
 java.util.Enumeration secondenum;
 int arranges;
  
 //constructor
 Graph() {
   nodes = new java.util.Hashtable(200);
   links = new java.util.Hashtable(500);
   shownodeid = true;
 } 
 
 //adds a node to the hashtable
 void add(Node anode) {
   nodes.put(anode.id, anode); 
   if(nodes.size() == 1) { 
     anode.fixed = true; 
     anode.x = window_width / 2;
     anode.y = window_height / 2;
   }
   arranges = 15;
 }
 
  //adds a link to the hashtable
 void add(Link alink) {
   String id = alink.node1.id + "-" + alink.node2.id;
   links.put(id, alink); 
 }
 
 //returns a Node object that has the specified id, or null if not found
 Node getNode(String id) {
  return (Node)nodes.get(id);
 }
 
 //returns the number of nodes
 int numNodes() {
   return nodes.size();
 }
 
 //draws all of the nodes
 void drawNodes() {
   for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         ((Node)graphenum.nextElement()).drawMe();
     }
 }
 
 //draws all of the links
 void drawLinks() {
   for(graphenum = links.elements() ; graphenum.hasMoreElements() ;) {
         ((Link)graphenum.nextElement()).drawMe();
     }
 }

//returns the closest node to the (x,y) coordinate passed in
Node getClosestNode(int x, int y) {
 int tolerance = 200;
 Node testNode, closestNode = null;
 int cloestDistance = tolerance, squaredDist;
 
 for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         testNode = (Node)graphenum.nextElement();
         squaredDist = squaredDistance(testNode.x, testNode.y, x, y);
         if(squaredDist < tolerance && squaredDist < cloestDistance) {
            closestNode = testNode;
            cloestDistance = squaredDist;
            }
     }
 
 return closestNode;
}

//performs one iteration of arrange
 void arrange() {
   if(arranges > 0) {
     for(graphenum = links.elements() ; graphenum.hasMoreElements() ;) {
         Link alink = ((Link)graphenum.nextElement());
         Node node1 = alink.node1; //to
         Node node2 = alink.node2; //from
         
         double vx = node1.x - node2.x;
	 double vy = node1.y - node2.y;
	 double len = Math.sqrt(vx * vx + vy * vy);
	 double f = (alink.len - len) / (len * 3) ;
	 double dx = f * vx;
	 double dy = f * vy;

	 node1.dx += dx;
	 node1.dy += dy;
	 node2.dx += -dx;
	 node2.dy += -dy;
     }
     
     for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         Node n1 = ((Node)graphenum.nextElement());
         double dx = 0;
	 double dy = 0;

        for(secondenum = nodes.elements() ; secondenum.hasMoreElements() ;) {
           Node n2 = ((Node)secondenum.nextElement());
            if (n2 == n1) {
		    continue;
		}
		double vx = n1.x - n2.x;
		double vy = n1.y - n2.y;
		double len = vx * vx + vy * vy;
		if (len == 0) {
		    dx += Math.random();
		    dy += Math.random();
		} else if (len < 100*100) {
		    dx += vx / len;
		    dy += vy / len;
		}
        }
        
         double dlen = dx * dx + dy * dy;
	 if (dlen > 0) {
		dlen = Math.sqrt(dlen) / 2;
		n1.dx += dx / dlen;
		n1.dy += dy / dlen;
	    }
     }
     
    for(graphenum = nodes.elements() ; graphenum.hasMoreElements() ;) {
         Node n = ((Node)graphenum.nextElement());
         if (!n.fixed) {
		n.x += Math.max(-5, Math.min(5, n.dx));
		n.y += Math.max(-5, Math.min(5, n.dy));
		//System.out.println("v= " + n.dx + "," + n.dy);
		/*if (n.x < 0) {
		    n.x = 0;
		} else if (n.x > window_width) {
		    n.x = window_width;
		}
		if (n.y < 0) {
		    n.y = 0;
		} else if (n.y > window_height) {
		    n.y = window_height;
		}*/
	    }
	    n.dx /= 2;
	    n.dy /= 2;
      }

     screenDirty= true;
     arranges--;
    }
  
 } //end arrange()
 
} //end Graph class
