
// A node object represents a point on the graph.
// This will be the individial peer.

class Node {
  
  String id;
  int x, y;
  
  boolean active;
  color nodecolor;
  java.util.Hashtable links = new java.util.Hashtable(10); 
  java.util.Enumeration nodeenum;
  
  double dx, dy;
  boolean fixed = false;
   
   //constructor
   Node(String myid) {
    id = myid;
    nodecolor = color((int)random(0, 255), (int)random(0, 255), (int)random(0, 255));
    x = (int)random(20, window_width-70);
    y = (int)random(100, window_height-20);
    active = true;
   }

   //instatiates a link object and adds it to both node's link arrays
   //returns true is successful, false if anothernode is null or inactive
   boolean connect(Node anothernode) {
     
     if(anothernode == null || anothernode == this || !anothernode.active) { return false;  }
     
     //make sure that we aren't already connected
      boolean alreadyconnected = false;
      if(links.get(anothernode.id) != null) { alreadyconnected = true; }

      //create a link object and add it to both nodes link arrays
      if(!alreadyconnected) {
       Link alink = new Link(this, anothernode);
       this.links.put(anothernode.id, alink);
       anothernode.links.put(this.id, alink);
      }
      return true;
   }
   
   //deletes the link from this node to anothernode
   //returns true is successful, false if anothernode is null
   boolean disconnect(Node anothernode) {
     
     if(anothernode == null || anothernode == this) { return false; }
     
     this.links.remove(anothernode.id);
     anothernode.links.remove(this.id);

     return true;
   }
   
   //sends a message to the destination via the link that connects them
   //returns true if successful, false if no link exists
   boolean sendMessage(Node destination, int numMessages) {
      if(destination == null || !destination.active || 
         destination == this || numMessages < 0) { return false; }
     
      Link thelink = (Link)links.get(destination.id);
      
      if(thelink != null) {
        thelink.messages += numMessages;
        return true;
      }
      
      return false;
   }
   
   //sets active as false and removes all links joining this node
   //returns false is node was already not active.
   boolean deactivate() {
      if(!active) { return false ; }
      
      //remove the link from the other node's link array
      for(nodeenum = links.keys() ; nodeenum.hasMoreElements() ;) {
         String nodeid = ((String)nodeenum.nextElement());
         graph.getNode(nodeid).links.remove(this.id);
      }
      
      //delete all links in this node
      links.clear();
      
      active = false;
      return true;
   }
   
   //draws the node primative at its (x,y) coordinate
   void drawMe() {
     if(active) {
       fill(nodeidblack);
        strokeJoin(ROUND); strokeCap(ROUND);  smooth(); 
        stroke(blue); strokeWeight(20); 
        beginShape(POINTS);  vertex(x, y); endShape();
        if(graph.shownodeid) { text(id, x+10, y-10); }
     }
   }
   
   //Changes the position coordinate of the node
   void changePosition(int x, int y) {
     this.x = x;
     this.y = y;
     screenDirty = true; 
   }
   
   //resets messages for each link stemming from this node to zero.
   void clearlinks() {
    for(nodeenum = links.elements() ; nodeenum.hasMoreElements() ;) {
         ((Link)nodeenum.nextElement()).messages = 0;
     }
   }
  
} //end Node class
