#!/usr/bin/perl -w
use strict;

use File::Basename;
use lib dirname($0);
use MyConfig;

# sends random "foo barX" $qcnt queries to each peer,
# sleeping 2-12 seconds inbetween

if (2 != @ARGV)
{
    die "Usage: $0 <Number Of Non-Hostcatcher Peers> <queriesPerPeer>\n\n(Or use 0 to make a peer for every index file)\n";
}
my $peer_cnt = $ARGV[0];
my $qcnt     = $ARGV[1];    


chdir($MyConfig::rootdir) || die "argh: $!";

# FYI: Currently, reading the index dir and looping over the entries
# is only useful if peer_cnt is zero (i.e. determined by the number of index files).
# And even then, its only used to get the number of peers
# to query.
opendir(DIR, $MyConfig::indexdir) || die "argh: $!";
my @entries = readdir DIR;
closedir DIR || die "argh: $!";

my $x = 0;

my @peers;
foreach (@entries)
{
    if (/^\.$/ or /^\.\.$/)
    {
        next;
    }

    my $idx = $_;

    my $loki_num = ($x % $MyConfig::MOD) + 2;
    my $ip = $MyConfig::prefix .".". ($MyConfig::offset+$loki_num);

    my $port1 = 2000 + $x + 1;
    my $port2 = 9000 + $x + 1;

    my $host = "loki$loki_num";

    push(@peers, "$ip:$port2");

    $x++;

    if ($x == $peer_cnt) {
        last;
    }
}

for (1..$qcnt) {
    for my $i (0 .. $#peers) {
        my $time = time(); 
        my $cmd = "../../build/odin-0.1/src/client $peers[$i] 1000 \"foo bar$i time$time\"";
        print "$cmd\n";
        system($cmd) == 0 or die "argh";
        sleep( int(2 + rand(10)) );
    }
}
