#!/usr/bin/perl -w
use strict;

use File::Basename;
use lib dirname($0);
use MyConfig;

# This program only prints the ssh invocation lines.


my ($option, $after);

if (1) {
    $option = "-f";
    $after  = "";
}
else {
    # Choose this only if 
    # 1) you won't have to approve connecting or enter a password. 
    # 2) you want the shell to tell you when ssh is done.
    $option = "-n";
    $after  = "&";
}


if (1 != @ARGV)
{
    die "Usage: $0 <Number Of Non-Hostcatcher Peers>\n\n(Or use 0 to make a peer for every index file)\n";
}
my $peer_cnt = $ARGV[0];

chdir($MyConfig::rootdir) || die "argh: $!";

opendir(DIR, $MyConfig::indexdir) || die "argh: $!";
my @entries = readdir DIR;
closedir DIR || die "argh: $!";


my @output;
push(@output, "ssh $option loki1 $MyConfig::rootdir/run_hostcatcher.sh $after\n");
push(@output, "sleep 5\n");

my $x = 0;
foreach (@entries)
{
    if (/^\.$/ or /^\.\.$/)
    {
        next;
    }

    my $idx = $_;

    my $loki_num = ($x % $MyConfig::MOD) + 2;
    my $ip = $MyConfig::prefix .".". ($MyConfig::offset+$loki_num);

    my $port1 = 2000 + $x + 1;
    my $port2 = 9000 + $x + 1;

    my $host = "loki$loki_num";

    push(@output, "ssh $option $host $MyConfig::rootdir/run_regular_peer.sh $port1 $port2 $ip $MyConfig::indexdir/$idx $after\n");

    $x++;

    if ($x == $peer_cnt) {
        last;
    }
}

if ($x < $peer_cnt)
{
    die "$peer_cnt is too high - There are only $x index files\n";
}

foreach (@output)
{
    print;
}
