#!/usr/bin/perl -w
use strict;

use File::Basename;
use lib dirname($0);
use MyConfig;

#unlike run_peers.pl, this actually executes the shutdown commands

if (1 != @ARGV)
{
    die "Usage: $0 <Number Of Non-Hostcatcher Peers>\n\n(Or use 0 to make a peer for every index file)\n";
}
my $peer_cnt = $ARGV[0];


chdir($MyConfig::rootdir) || die "argh: $!";

# FYI: Currently, reading the index dir and looping over the entries
# is only useful if peer_cnt is zero (i.e. determined by the number of index files).
# And even then, its only used to get the number of peers 
# to shutdown.
opendir(DIR, $MyConfig::indexdir) || die "argh: $!";
my @entries = readdir DIR;
closedir DIR || die "argh: $!";

my $x = 0;

my @peers;
foreach (@entries)
{
    if (/^\.$/ or /^\.\.$/)
    {
        next;
    }

    my $idx = $_;

    my $loki_num = ($x % $MyConfig::MOD) + 2;
    my $ip = $MyConfig::prefix .".". ($MyConfig::offset+$loki_num);

    my $port1 = 2000 + $x + 1;
    my $port2 = 9000 + $x + 1;

    my $host = "loki$loki_num";

    push(@peers, "$ip:$port2");

    $x++;

    if ($x == $peer_cnt) {
        last;
    }
}

push(@peers, "130.207.104.34:2000");

for my $i (0 .. $#peers) {
    my $time = time(); 
    my $cmd = "../../build/odin-0.1/src/client $peers[$i] 2002 \"\"";
    print "$cmd\n";
    system($cmd) == 0 or die "argh";
}
