#!/usr/bin/perl -w
use strict;

open(ALLOWED, (shift @ARGV)) || die "argh";

my %allowed;
while (<ALLOWED>)
{
    chomp;
    s/\s+//;
    $allowed{$_} = 1;
}

close(ALLOWED) || die "argh";

my %allowed_urls;

while (<>) 
{
    if (/^\s*#/)
    {
        print;
    }
    elsif (/^DP,"([^"]+)","(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}:\d+)"$/)
    {
        if (exists $allowed{$2})
        {
            print;
            $allowed_urls{$1} = $2;
        }
    }
    elsif (/QD,"[^"]+","([^"]+)"/) {
        if (exists $allowed_urls{$1})
        {
            print;
        }
    }
    elsif (/PI,"mainindex","(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}:\d+)",\d+/) 
    {
        if (exists $allowed{$1})
        {
            print;
        }
    }
    else
    {
        die "argh: $_";
    }
}
