import java.io.BufferedReader;
import java.io.FileReader;

public class LogFile {

    private BufferedReader source;

    private static final int BUFFER_SIZE = 1024;
    private int buffer_position = BUFFER_SIZE;
    private Record[] buffer = new Record[BUFFER_SIZE];

    public LogFile(String filename) throws java.io.FileNotFoundException {
        this.source = new BufferedReader(new FileReader(filename));
    }

    public void close() throws java.io.IOException {
        this.source.close();
    }

    /* Fetch the next record in this logfile. */
    public Record next() throws java.io.IOException {
        String data;
        Record record = null;
        /* fill the buffer if empty */
        if (this.buffer_position == BUFFER_SIZE){
            this.readLines();
        }
        if (this.buffer[buffer_position] == null){
            return null;
        }

        return this.buffer[buffer_position++];
    }

    /**
     * Fill internal buffer.
     */
    private void readLines() throws java.io.IOException{
        int i;
        String data;
        Record record;

        for (i=0; i<BUFFER_SIZE; i++){
            record = null;
            data = null;
            do {
                data = this.source.readLine();
                if (data == null) { break; }
                /* check for a valid record */
            }while (!Record.valid(data)); 

            if (data != null) { 
                record = new Record(this,data);
            }

            this.buffer[i] = record;
        }
        this.buffer_position = 0;
    }
}
